<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelRentProdResOpService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function find($conditions){
        $params = array(
         	':TIPOCUSTO'        => $conditions['CDTIPOCUSTO'],
         	':CDFILIAL'         => $conditions['CDFILIAL'],
         	':TCDFILIAL'        => $conditions['TCDFILIAL'],
         	':NRORG'            => $conditions['NRORG'],
         	':CDLOJA'           => $conditions['CDLOJA'],
            ':TCDLOJA'          => $conditions['TCDLOJA'],        	
         	':MESDATA'          => $conditions['MESDATA'],
         	':ANODATA'          => $conditions['ANODATA'],
         	':DTINI'            => $conditions['DTINI'],
         	':DTFIN'            => $conditions['DTFIN'],
         	':CDNVPRODUTOAGRUP' => '2',
         	':PRODNIV'          => $conditions['PRODNIV'],
         	':TCDPRODUTO'       => $conditions['TCDPRODUTO'],
         	':CDPRODLIST'       => $conditions['CDPRODLIST'],
         	':CDARVPRODF'       => $conditions['CDARVPRODF'],
         	':CDARVPRODI'       => $conditions['CDARVPRODI']
 		);
        
 		if($conditions['FLAGIMPOSTO'] == 'C') {
 		    $primeiro = $this->entityManager->getConnection()->fetchAll(self::PRIMEIRA_QUERY, $params);
 		    $segundo  = $this->entityManager->getConnection()->fetchAll(self::SEGUNDA_QUERY, $params);
 		} else {
 		    $primeiro = $this->entityManager->getConnection()->fetchAll(self::PRIMEIRA_QUERY_SEM_IMPOSTO, $params);
 		    $segundo  = $this->entityManager->getConnection()->fetchAll(self::SEGUNDA_QUERY_SEM_IMPOSTO, $params);
 		}
 		
 		$terceiro = $this->somaArrays($primeiro, $segundo);
 		
        return $terceiro;
    }
    
    private function somaArrays($primeiro, $segundo) {
        $resultado = array_merge($primeiro, $segundo);

        $agrupado = array_reduce($resultado, function($carry, $item) {
            $key = $item['CDFILIAL'] . '-' . $item['CDLOJA'] . '-' . $item['NMPRODUTO'] . '-' . $item['NMPRODUTOAVO'];
            
            if(isset($carry[$key])) {
                $carry[$key]['VRTOTAL']    += $item['VRTOTAL'];
                $carry[$key]['VRIMPOSTO']  += $item['VRIMPOSTO'];
                $carry[$key]['VRCUSTO']    += $item['VRCUSTO'];
                $carry[$key]['QTPRODVEND'] += $item['QTPRODVEND']; 
            } else {
                $carry[$key] = $item;
            }
            
            return $carry;
        }, []);
        
        $terceiro = array_values($agrupado);
        
        return $terceiro;
    }
    
    const PRIMEIRA_QUERY = "
        SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
                CASE I.VRUNITVEND
                    WHEN 0
                        THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0))
                    ELSE I.VRUNITVEND
                END AS VRUNITVEND,
                SUM(I.QTPRODVEND) AS QTPRODVEND, 
                SUM((TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) * M.VRPEALPRODIT / 100) AS VRIMPOSTO,
                SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
                SUM(CUSTO_COMPOSICAO(I.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, I.QTPRODVEND, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
                :TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO , :TIPOCUSTO AS IDCUSFOPRECO, 
                PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO, R.VRROYALTIESPERC, 
                R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
            FROM ITEMVENDA I
                JOIN PRODUTO P
                    ON I.CDPRODUTO = P.CDPRODUTO
                        AND I.NRORG = P.NRORG
                JOIN PRODUTO PV
                    ON P.NRORG = PV.NRORG
                JOIN ITVENDAIMPOS M
                    ON I.CDFILIAL = M.CDFILIAL
                        AND I.CDCAIXA = M.CDCAIXA
                        AND I.NRSEQVENDA = M.NRSEQVENDA
                        AND I.NRSEQUITVEND = M.NRSEQUITVEND
                JOIN (
                    SELECT V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, 
                            FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTENTRVENDA
                        FROM VENDA V
                            JOIN (
                                SELECT C.CDCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                    FROM CAIXA C
                                        JOIN (
                                            SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                                FROM LOJA L
                                                    JOIN (
                                                        SELECT CDFILIAL, NMFILIAL, NRORG
                                                            FROM FILIAL
                                                            WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                    ) FI
                                                        ON L.CDFILIAL = FI.CDFILIAL
                                                            AND L.NRORG = FI.NRORG
                                                WHERE ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                        ) FILO
                                            ON C.CDFILIAL = FILO.CDFILIAL
                                                AND C.CDLOJA = FILO.CDLOJA
                                                AND C.NRORG = FILO.NRORG
                            ) FILOCA
                                ON V.CDCAIXA       = FILOCA.CDCAIXA
                                    AND V.CDLOJA   = FILOCA.CDLOJA
                                    AND V.CDFILIAL = FILOCA.CDFILIAL
                                    AND V.NRORG    = FILOCA.NRORG
                        WHERE V.IDSITUVENDA = 'O'
                            AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                ) FILOCAVE
                    ON FILOCAVE.CDFILIAL = M.CDFILIAL
                        AND FILOCAVE.CDCAIXA = M.CDCAIXA
                        AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
                JOIN RENTPRODOP R
                    ON R.CDFILIAL = FILOCAVE.CDFILIAL
                        AND R.CDLOJA = FILOCAVE.CDLOJA
            WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
                AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
                AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
                AND PV.NRORG = :NRORG
                AND R.CDMES = :MESDATA
                AND R.CDANO = :ANODATA 
            GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO,
                    P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO, PV.CDPRODUTO, PV.NMPRODUTO, 
                    R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
    ";
    
    const SEGUNDA_QUERY = "
        SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, 
                CASE I.VRUNITVEND
                    WHEN 0
                        THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0))
                    ELSE I.VRUNITVEND
                END AS VRUNITVEND,
                0 AS QTPRODVEND, 0 AS VRIMPOSTO, 0 AS VRTOTAL,
				SUM(CUSTO_COMPOSICAO(M.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, M.QTITVENDAEST, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
				:TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO, :TIPOCUSTO AS IDCUSFOPRECO, PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO,
                R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
            FROM ITEMVENDA I
                JOIN PRODUTO P
                	ON I.CDPRODUTO = P.CDPRODUTO
                   		AND I.NRORG = P.NRORG
				JOIN PRODUTO PV
                    ON P.NRORG = PV.NRORG
				JOIN ITEMVENDAEST M
                    ON I.CDFILIAL = M.CDFILIAL
                   		AND I.CDCAIXA = M.CDCAIXA
                   		AND I.NRSEQVENDA = M.NRSEQVENDA
                   		AND I.NRSEQUITVEND = M.NRSEQUITVEND
                JOIN (
                    SELECT V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, 
                            FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTENTRVENDA
                        FROM VENDA V
                            JOIN (
                                SELECT C.CDCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                    FROM CAIXA C
                                        JOIN (
                                            SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                                FROM LOJA L
                                                    JOIN (
                                                        SELECT CDFILIAL, NMFILIAL, NRORG
                                                            FROM FILIAL
                                                            WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                    ) FI
                                                        ON L.CDFILIAL = FI.CDFILIAL
                                                            AND L.NRORG = FI.NRORG
                                                WHERE ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                        ) FILO
                                            ON C.CDFILIAL = FILO.CDFILIAL
                                                AND C.CDLOJA = FILO.CDLOJA
                                                AND C.NRORG = FILO.NRORG
                            ) FILOCA
                                ON V.CDCAIXA       = FILOCA.CDCAIXA
                                    AND V.CDLOJA   = FILOCA.CDLOJA
                                    AND V.CDFILIAL = FILOCA.CDFILIAL
                                    AND V.NRORG    = FILOCA.NRORG
                        WHERE V.IDSITUVENDA = 'O'
                            AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                ) FILOCAVE
                    ON FILOCAVE.CDFILIAL = M.CDFILIAL
                   		AND FILOCAVE.CDCAIXA = M.CDCAIXA
                   		AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
                JOIN RENTPRODOP R
                    ON R.CDFILIAL = FILOCAVE.CDFILIAL
                        AND R.CDLOJA = FILOCAVE.CDLOJA
            WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
				AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
				AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
				AND PV.NRORG = :NRORG
                AND R.CDMES = :MESDATA
                AND R.CDANO = :ANODATA
            GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO,
                    P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO, PV.CDPRODUTO, PV.NMPRODUTO, 
                    R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
    ";
    
    const PRIMEIRA_QUERY_SEM_IMPOSTO = "
        SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
                CASE I.VRUNITVEND
                    WHEN 0
                        THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0))
                    ELSE I.VRUNITVEND
                END AS VRUNITVEND,
                SUM(I.QTPRODVEND) AS QTPRODVEND, 
                0 AS VRIMPOSTO,
                SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
                SUM(CUSTO_COMPOSICAO(I.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, I.QTPRODVEND, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
                :TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO , :TIPOCUSTO AS IDCUSFOPRECO, 
                PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO, R.VRROYALTIESPERC, 
                R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
            FROM ITEMVENDA I
                JOIN PRODUTO P
                    ON I.CDPRODUTO = P.CDPRODUTO
                        AND I.NRORG = P.NRORG
                JOIN PRODUTO PV
                    ON P.NRORG = PV.NRORG
                JOIN (
                    SELECT V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, 
                            FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTENTRVENDA
                        FROM VENDA V
                            JOIN (
                                SELECT C.CDCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                    FROM CAIXA C
                                        JOIN (
                                            SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                                FROM LOJA L
                                                    JOIN (
                                                        SELECT CDFILIAL, NMFILIAL, NRORG
                                                            FROM FILIAL
                                                            WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                    ) FI
                                                        ON L.CDFILIAL = FI.CDFILIAL
                                                            AND L.NRORG = FI.NRORG
                                                WHERE ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                        ) FILO
                                            ON C.CDFILIAL = FILO.CDFILIAL
                                                AND C.CDLOJA = FILO.CDLOJA
                                                AND C.NRORG = FILO.NRORG
                            ) FILOCA
                                ON V.CDCAIXA       = FILOCA.CDCAIXA
                                    AND V.CDLOJA   = FILOCA.CDLOJA
                                    AND V.CDFILIAL = FILOCA.CDFILIAL
                                    AND V.NRORG    = FILOCA.NRORG
                        WHERE V.IDSITUVENDA = 'O'
                            AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                ) FILOCAVE
                    ON FILOCAVE.CDFILIAL = I.CDFILIAL
                        AND FILOCAVE.CDCAIXA = I.CDCAIXA
                        AND FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
                JOIN RENTPRODOP R
                    ON R.CDFILIAL = FILOCAVE.CDFILIAL
                        AND R.CDLOJA = FILOCAVE.CDLOJA
            WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
                AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
                AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
                AND PV.NRORG = :NRORG
                AND R.CDMES = :MESDATA
                AND R.CDANO = :ANODATA 
            GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO,
                P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO, PV.CDPRODUTO, PV.NMPRODUTO, 
                R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
    ";
    
    const SEGUNDA_QUERY_SEM_IMPOSTO = "
        SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, 
                CASE I.VRUNITVEND
                    WHEN 0
                        THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0))
                    ELSE I.VRUNITVEND
                END AS VRUNITVEND,
                0 AS QTPRODVEND, 0 AS VRIMPOSTO, 0 AS VRTOTAL,
                SUM(CUSTO_COMPOSICAO(M.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, M.QTITVENDAEST, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
                :TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO, :TIPOCUSTO AS IDCUSFOPRECO, PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO,
                R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
            FROM ITEMVENDA I
                JOIN PRODUTO P
                    ON I.CDPRODUTO = P.CDPRODUTO
                        AND I.NRORG = P.NRORG
                JOIN PRODUTO PV
                    ON P.NRORG = PV.NRORG
                JOIN ITEMVENDAEST M
                    ON I.CDFILIAL = M.CDFILIAL
                        AND I.CDCAIXA = M.CDCAIXA
                        AND I.NRSEQVENDA = M.NRSEQVENDA
                        AND I.NRSEQUITVEND = M.NRSEQUITVEND
                JOIN (
                    SELECT V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, 
                            FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTENTRVENDA
                        FROM VENDA V
                            JOIN (
                                SELECT C.CDCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                    FROM CAIXA C
                                        JOIN (
                                            SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                                FROM LOJA L
                                                    JOIN (
                                                        SELECT CDFILIAL, NMFILIAL, NRORG
                                                            FROM FILIAL
                                                            WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                    ) FI
                                                        ON L.CDFILIAL = FI.CDFILIAL
                                                            AND L.NRORG = FI.NRORG
                                                WHERE ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                        ) FILO
                                            ON C.CDFILIAL = FILO.CDFILIAL
                                                AND C.CDLOJA = FILO.CDLOJA
                                                AND C.NRORG = FILO.NRORG
                            ) FILOCA
                                ON V.CDCAIXA       = FILOCA.CDCAIXA
                                    AND V.CDLOJA   = FILOCA.CDLOJA
                                    AND V.CDFILIAL = FILOCA.CDFILIAL
                                    AND V.NRORG    = FILOCA.NRORG
                        WHERE V.IDSITUVENDA = 'O'
                            AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                ) FILOCAVE
                    ON FILOCAVE.CDFILIAL = M.CDFILIAL
                        AND FILOCAVE.CDCAIXA = M.CDCAIXA
                        AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
                JOIN RENTPRODOP R
                    ON R.CDFILIAL = FILOCAVE.CDFILIAL
                        AND R.CDLOJA = FILOCAVE.CDLOJA
            WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
                AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
                AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
                AND PV.NRORG = :NRORG
                AND R.CDMES = :MESDATA
                AND R.CDANO = :ANODATA
            GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO,
                P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO, PV.CDPRODUTO, PV.NMPRODUTO, 
                R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
    ";

    const GET_RENTABILIDADE_ANALITICO = "
        SELECT CDFILIAL || ' - ' || NMFILIAL AS LABELFILIAL, CDLOJA || ' - ' || NMLOJA AS LABELLOJA,
                CDFILIAL, NMFILIAL, CDLOJA, NMLOJA, CDPRODUTO, CDARVPROD, NMPRODUTO, CDPRODUTOAVO, 
                NMPRODUTOAVO, VRUNITVEND, 
                SUM(QTPRODVEND) AS QTPRODVEND, 
                SUM(VRIMPOSTO) AS VRIMPOSTO,
                SUM(VRTOTAL) AS VRTOTAL,
                SUM(VRCUSTO) AS VRCUSTO,
                CDTIPOCUSTO, NMTIPOCUSTO, IDCUSFOPRECO,
                ROUND((SUM(VRCUSTO)/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2) AS CUSTOUNIT,
                ROUND(((ROUND((SUM(VRCUSTO)/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2)/DECODE(VRUNITVEND, 0, 1, VRUNITVEND)) * 100) , 2) AS PERCCUS,
                VRM2, VRQFR, VRQFP, VRROYALTIESPERC, VRFPROPMARKPERC, VRGASTOSLOJA, VRODPERC
            FROM (
                SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
                        CASE I.VRUNITVEND
                            WHEN 0
                                THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0))
                            ELSE I.VRUNITVEND
                        END AS VRUNITVEND,
                        SUM(I.QTPRODVEND) AS QTPRODVEND, 
                        SUM((TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) * M.VRPEALPRODIT / 100) AS VRIMPOSTO,
                        SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
                        SUM(CUSTO_COMPOSICAO(I.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, I.QTPRODVEND, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
                        :TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO , :TIPOCUSTO AS IDCUSFOPRECO, 
                        PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO, R.VRROYALTIESPERC, 
                        R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
                    FROM ITEMVENDA I
                        JOIN PRODUTO P
                            ON I.CDPRODUTO = P.CDPRODUTO
                                AND I.NRORG = P.NRORG
                        JOIN PRODUTO PV
                            ON P.NRORG = PV.NRORG
                        JOIN ITVENDAIMPOS M
                            ON I.CDFILIAL = M.CDFILIAL
                                AND I.CDCAIXA = M.CDCAIXA
                                AND I.NRSEQVENDA = M.NRSEQVENDA
                                AND I.NRSEQUITVEND = M.NRSEQUITVEND
                        JOIN (
                            SELECT V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, 
                                    FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTENTRVENDA
                                FROM VENDA V
                                    JOIN (
                                        SELECT C.CDCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                            FROM CAIXA C
                                                JOIN (
                                                    SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                                        FROM LOJA L
                                                            JOIN (
                                                                SELECT CDFILIAL, NMFILIAL, NRORG
                                                                    FROM FILIAL
                                                                    WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                            ) FI
                                                                ON L.CDFILIAL = FI.CDFILIAL
                                                                    AND L.NRORG = FI.NRORG
                                                        WHERE ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                                ) FILO
                                                    ON C.CDFILIAL = FILO.CDFILIAL
                                                        AND C.CDLOJA = FILO.CDLOJA
                                                        AND C.NRORG = FILO.NRORG
                                    ) FILOCA
                                        ON V.CDCAIXA       = FILOCA.CDCAIXA
                                            AND V.CDLOJA   = FILOCA.CDLOJA
                                            AND V.CDFILIAL = FILOCA.CDFILIAL
                                            AND V.NRORG    = FILOCA.NRORG
                                WHERE V.IDSITUVENDA = 'O'
                                    AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                        ) FILOCAVE
                            ON FILOCAVE.CDFILIAL = M.CDFILIAL
                                AND FILOCAVE.CDCAIXA = M.CDCAIXA
                                AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
                        JOIN RENTPRODOP R
                            ON R.CDFILIAL = FILOCAVE.CDFILIAL
                                AND R.CDLOJA = FILOCAVE.CDLOJA
                    WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
                        AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
                        AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
                        AND PV.NRORG = :NRORG
                        AND R.CDMES = :MESDATA
                        AND R.CDANO = :ANODATA 
                    GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO,
                            P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO, PV.CDPRODUTO, PV.NMPRODUTO, 
                            R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
        
                UNION
        
                SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, 
                        CASE I.VRUNITVEND
                            WHEN 0
                                THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0))
                            ELSE I.VRUNITVEND
                        END AS VRUNITVEND,
                        0 AS QTPRODVEND, 0 AS VRIMPOSTO, 0 AS VRTOTAL,
        				SUM(CUSTO_COMPOSICAO(M.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, M.QTITVENDAEST, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
        				:TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO, :TIPOCUSTO AS IDCUSFOPRECO, PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO,
                        R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
                    FROM ITEMVENDA I
                        JOIN PRODUTO P
                        	ON I.CDPRODUTO = P.CDPRODUTO
                           		AND I.NRORG = P.NRORG
        				JOIN PRODUTO PV
                            ON P.NRORG = PV.NRORG
        				JOIN ITEMVENDAEST M
                            ON I.CDFILIAL = M.CDFILIAL
                           		AND I.CDCAIXA = M.CDCAIXA
                           		AND I.NRSEQVENDA = M.NRSEQVENDA
                           		AND I.NRSEQUITVEND = M.NRSEQUITVEND
                        JOIN (
                            SELECT V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, 
                                    FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTENTRVENDA
                                FROM VENDA V
                                    JOIN (
                                        SELECT C.CDCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                            FROM CAIXA C
                                                JOIN (
                                                    SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                                        FROM LOJA L
                                                            JOIN (
                                                                SELECT CDFILIAL, NMFILIAL, NRORG
                                                                    FROM FILIAL
                                                                    WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                            ) FI
                                                                ON L.CDFILIAL = FI.CDFILIAL
                                                                    AND L.NRORG = FI.NRORG
                                                        WHERE ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                                ) FILO
                                                    ON C.CDFILIAL = FILO.CDFILIAL
                                                        AND C.CDLOJA = FILO.CDLOJA
                                                        AND C.NRORG = FILO.NRORG
                                    ) FILOCA
                                        ON V.CDCAIXA       = FILOCA.CDCAIXA
                                            AND V.CDLOJA   = FILOCA.CDLOJA
                                            AND V.CDFILIAL = FILOCA.CDFILIAL
                                            AND V.NRORG    = FILOCA.NRORG
                                WHERE V.IDSITUVENDA = 'O'
                                    AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                        ) FILOCAVE
                            ON FILOCAVE.CDFILIAL = M.CDFILIAL
                           		AND FILOCAVE.CDCAIXA = M.CDCAIXA
                           		AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
                        JOIN RENTPRODOP R
                            ON R.CDFILIAL = FILOCAVE.CDFILIAL
                                AND R.CDLOJA = FILOCAVE.CDLOJA
                    WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
        				AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
        				AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
        				AND PV.NRORG = :NRORG
                        AND R.CDMES = :MESDATA
                        AND R.CDANO = :ANODATA
                    GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO,
                            P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO, PV.CDPRODUTO, PV.NMPRODUTO, 
                            R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
            )
            GROUP BY CDFILIAL, NMFILIAL, CDLOJA, NMLOJA, CDPRODUTO, CDARVPROD, NMPRODUTO, 
                CDPRODUTOAVO, NMPRODUTOAVO, VRUNITVEND, CDTIPOCUSTO, NMTIPOCUSTO, IDCUSFOPRECO,
                VRM2, VRQFR, VRQFP, VRROYALTIESPERC, VRFPROPMARKPERC, VRGASTOSLOJA, VRODPERC
        ORDER BY CDFILIAL ASC, CDLOJA ASC
    ";
    
    const GET_RENTABILIDADE_ANALITICO_SEM_IMPOSTO = "
        SELECT CDFILIAL || ' - ' || NMFILIAL AS LABELFILIAL, CDLOJA || ' - ' || NMLOJA AS LABELLOJA,
                CDFILIAL, NMFILIAL, CDLOJA, NMLOJA, CDPRODUTO, CDARVPROD, NMPRODUTO, CDPRODUTOAVO, 
                NMPRODUTOAVO, VRUNITVEND, 
                SUM(QTPRODVEND) AS QTPRODVEND, 
                0 AS VRIMPOSTO,
                SUM(VRTOTAL) AS VRTOTAL,
                SUM(VRCUSTO) AS VRCUSTO,
                CDTIPOCUSTO, NMTIPOCUSTO, IDCUSFOPRECO,
                ROUND((SUM(VRCUSTO)/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2) AS CUSTOUNIT,
                ROUND(((ROUND((SUM(VRCUSTO)/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2)/DECODE(VRUNITVEND, 0, 1, VRUNITVEND)) * 100) , 2) AS PERCCUS,
                VRM2, VRQFR, VRQFP, VRROYALTIESPERC, VRFPROPMARKPERC, VRGASTOSLOJA, VRODPERC
            FROM (
                SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
                        CASE I.VRUNITVEND
                            WHEN 0
                                THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0))
                            ELSE I.VRUNITVEND
                        END AS VRUNITVEND,
                        SUM(I.QTPRODVEND) AS QTPRODVEND, 
                        0 AS VRIMPOSTO,
                        SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
                        SUM(CUSTO_COMPOSICAO(I.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, I.QTPRODVEND, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
                        :TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO , :TIPOCUSTO AS IDCUSFOPRECO, 
                        PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO, R.VRROYALTIESPERC, 
                        R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
                    FROM ITEMVENDA I
                        JOIN PRODUTO P
                            ON I.CDPRODUTO = P.CDPRODUTO
                                AND I.NRORG = P.NRORG
                        JOIN PRODUTO PV
                            ON P.NRORG = PV.NRORG
                        JOIN (
                            SELECT V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, 
                                    FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTENTRVENDA
                                FROM VENDA V
                                    JOIN (
                                        SELECT C.CDCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                            FROM CAIXA C
                                                JOIN (
                                                    SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                                        FROM LOJA L
                                                            JOIN (
                                                                SELECT CDFILIAL, NMFILIAL, NRORG
                                                                    FROM FILIAL
                                                                    WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                            ) FI
                                                                ON L.CDFILIAL = FI.CDFILIAL
                                                                    AND L.NRORG = FI.NRORG
                                                        WHERE ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                                ) FILO
                                                    ON C.CDFILIAL = FILO.CDFILIAL
                                                        AND C.CDLOJA = FILO.CDLOJA
                                                        AND C.NRORG = FILO.NRORG
                                    ) FILOCA
                                        ON V.CDCAIXA       = FILOCA.CDCAIXA
                                            AND V.CDLOJA   = FILOCA.CDLOJA
                                            AND V.CDFILIAL = FILOCA.CDFILIAL
                                            AND V.NRORG    = FILOCA.NRORG
                                WHERE V.IDSITUVENDA = 'O'
                                    AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                        ) FILOCAVE
                            ON FILOCAVE.CDFILIAL = I.CDFILIAL
                                AND FILOCAVE.CDCAIXA = I.CDCAIXA
                                AND FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
                        JOIN RENTPRODOP R
                            ON R.CDFILIAL = FILOCAVE.CDFILIAL
                                AND R.CDLOJA = FILOCAVE.CDLOJA
                    WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
                        AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
                        AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
                        AND PV.NRORG = :NRORG
                        AND R.CDMES = :MESDATA
                        AND R.CDANO = :ANODATA 
                    GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO,
                        P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO, PV.CDPRODUTO, PV.NMPRODUTO, 
                        R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
                
                UNION
                
                SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, 
                        CASE I.VRUNITVEND
                            WHEN 0
                                THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0))
                            ELSE I.VRUNITVEND
                        END AS VRUNITVEND,
                        0 AS QTPRODVEND, 0 AS VRIMPOSTO, 0 AS VRTOTAL,
                        SUM(CUSTO_COMPOSICAO(M.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, M.QTITVENDAEST, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
                        :TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO, :TIPOCUSTO AS IDCUSFOPRECO, PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO,
                        R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
                    FROM ITEMVENDA I
                        JOIN PRODUTO P
                            ON I.CDPRODUTO = P.CDPRODUTO
                                AND I.NRORG = P.NRORG
                        JOIN PRODUTO PV
                            ON P.NRORG = PV.NRORG
                        JOIN ITEMVENDAEST M
                            ON I.CDFILIAL = M.CDFILIAL
                                AND I.CDCAIXA = M.CDCAIXA
                                AND I.NRSEQVENDA = M.NRSEQVENDA
                                AND I.NRSEQUITVEND = M.NRSEQUITVEND
                        JOIN (
                            SELECT V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, 
                                    FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTENTRVENDA
                                FROM VENDA V
                                    JOIN (
                                        SELECT C.CDCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                            FROM CAIXA C
                                                JOIN (
                                                    SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                                        FROM LOJA L
                                                            JOIN (
                                                                SELECT CDFILIAL, NMFILIAL, NRORG
                                                                    FROM FILIAL
                                                                    WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                            ) FI
                                                                ON L.CDFILIAL = FI.CDFILIAL
                                                                    AND L.NRORG = FI.NRORG
                                                        WHERE ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                                ) FILO
                                                    ON C.CDFILIAL = FILO.CDFILIAL
                                                        AND C.CDLOJA = FILO.CDLOJA
                                                        AND C.NRORG = FILO.NRORG
                                    ) FILOCA
                                        ON V.CDCAIXA       = FILOCA.CDCAIXA
                                            AND V.CDLOJA   = FILOCA.CDLOJA
                                            AND V.CDFILIAL = FILOCA.CDFILIAL
                                            AND V.NRORG    = FILOCA.NRORG
                                WHERE V.IDSITUVENDA = 'O'
                                    AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
                        ) FILOCAVE
                            ON FILOCAVE.CDFILIAL = M.CDFILIAL
                                AND FILOCAVE.CDCAIXA = M.CDCAIXA
                                AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
                        JOIN RENTPRODOP R
                            ON R.CDFILIAL = FILOCAVE.CDFILIAL
                                AND R.CDLOJA = FILOCAVE.CDLOJA
                    WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
                        AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
                        AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
                        AND PV.NRORG = :NRORG
                        AND R.CDMES = :MESDATA
                        AND R.CDANO = :ANODATA
                    GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO,
                        P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO, PV.CDPRODUTO, PV.NMPRODUTO, 
                        R.VRROYALTIESPERC, R.VRFPROPMARKPERC, R.VRGASTOSLOJA, R.VRODPERC, R.VRQFR, R.VRQFP, R.VRM2
            )
            GROUP BY CDFILIAL, NMFILIAL, CDLOJA, NMLOJA, CDPRODUTO, CDARVPROD, NMPRODUTO, 
                CDPRODUTOAVO, NMPRODUTOAVO, VRUNITVEND, CDTIPOCUSTO, NMTIPOCUSTO, IDCUSFOPRECO,
                VRM2, VRQFR, VRQFP, VRROYALTIESPERC, VRFPROPMARKPERC, VRGASTOSLOJA, VRODPERC
        ORDER BY CDFILIAL ASC, CDLOJA ASC
    ";
}